(package-initialize)
(require 'package)

(global-set-key (kbd "C-?") 'help-command)
(global-set-key (kbd "M-?") 'mark-paragraph)
(global-set-key (kbd "C-h") 'delete-backward-char)
(global-set-key (kbd "<backspace>") 'delete-forward-char)
(global-set-key (kbd "C-S-h") 'kill-whole-line)
(global-set-key (kbd "M-h") 'backward-kill-word)

(global-set-key (kbd "H-/") 'make-frame-command)
(global-set-key (kbd "H-\\") 'delete-frame)

(defun x-face-height (arg)
  "Face height is set."
  (interactive "nInsert number: ")
  (set-face-attribute 'default (selected-frame) :height arg))
(global-set-key (kbd "H-=") 'x-face-height)

(add-hook 'emacs-lisp-mode-hook 'show-paren-mode)

(global-set-key	(kbd "s-l")	'forward-paragraph)
(global-set-key	(kbd "s-p")	'backward-paragraph)
(global-set-key	(kbd "s-[")	'recenter-top-bottom)

(global-set-key	(kbd "s-.")	'next-line)
(global-set-key	(kbd "s-;")	'previous-line)

(setq user-mail-address "xxx@bughat.com"
      user-full-name "xxx"
      calendar-location-name "xxx, xxx"
      calendar-longitude xxx.xxx
      calendar-latitude xxx.xxx)

(global-set-key (kbd "C-x C-b") 'ibuffer)
(set-face-background 'fringe "gray")

(defun x-normal-frame-size ()
  "Frame size is normal."
  (interactive)
  (set-frame-size (selected-frame) 84 24))
(global-set-key (kbd "H-p") 'x-normal-frame-size)

(defun x-focus-frame-size ()
  "Focus frame size is normal."
  (interactive)
  (progn
   (set-face-attribute 'default (selected-frame) :height 200)
    (set-frame-size (selected-frame) 84 24)))
(global-set-key (kbd "H-_") 'x-focus-frame-size)

(setq locale-coding-system 'utf-8)
(set-terminal-coding-system 'utf-8)
(set-keyboard-coding-system 'utf-8)
(set-selection-coding-system 'utf-8)
(prefer-coding-system 'utf-8)

(global-set-key (kbd "H-0") 'delete-window)
(global-set-key (kbd "H--") 'delete-other-windows)
(global-set-key (kbd "H-o") 'other-window)

(global-set-key (kbd "H-'") 'delete-frame)

(defun x-wide-frame-size ()
  "Frame size is wide."
  (interactive)
  (set-frame-size (selected-frame) 103 36))
(global-set-key (kbd "H-l") 'x-wide-frame-size)

(defun x-org-tree-to-indirect-buffer-jump ()
  "let indirect buffer take full window frame"
  (interactive)
  (prog1
      (org-tree-to-indirect-buffer)
    (delete-window)))

(add-hook 'org-mode-hook
	  (lambda ()
	    (define-key org-mode-map (kbd "H-.")
	      'x-org-tree-to-indirect-buffer-jump)))

(add-hook 'eww-mode-hook
	  (lambda ()
	    (define-key eww-mode-map (kbd "H-|")
	      'hl-line-mode)))

(add-hook 'eww-mode-hook
	  (lambda ()
	    (define-key eww-mode-map (kbd "b")
	      'scroll-down-command)))

(add-hook 'view-mode-hook
	  (lambda ()
	    (define-key view-mode-map (kbd "b")
	      'View-scroll-page-backward)))

(add-hook 'help-mode-hook
	  (lambda ()
	    (define-key help-mode-map (kbd "b")
	      'scroll-down-command)))

(add-hook 'log-view-mode-hook
	  (lambda ()
	    (define-key log-view-mode-map (kbd "b")
	      'scroll-down-command)))

;;; -----

(custom-set-variables
 ;; custom-set-variables was added by Custom.
 ;; If you edit it by hand, you could mess it up, so be careful.
 ;; Your init file should contain only one such instance.
 ;; If there is more than one, they won't work right.
 '(canlock-password "600dcbcafd9de585fe73fa9e0b97b5bec1f2dab1")
 '(display-buffer-reuse-frames t)
 '(electric-indent-mode nil)
 '(epa-pinentry-mode (quote loopback))
 '(gnus-summary-line-format "%U%R%z%I%(%[%4L: %-2,2f%]%) %s
")
 '(mac-command-modifier (quote alt))
 '(mac-option-modifier (quote meta))
 '(mac-right-command-modifier (quote super))
 '(mac-right-option-modifier (quote hyper))
 '(menu-bar-mode nil)
 '(org-return-follows-link t)
 '(ring-bell-function (quote ignore))
 '(safe-local-variable-values (quote ((eval auto-revert-mode t))))
 '(same-window-buffer-names (quote ("*vc-diff*" "*vc-change-log*")))
 '(scroll-bar-mode nil)
 '(tool-bar-mode nil))
(custom-set-faces
 ;; custom-set-faces was added by Custom.
 ;; If you edit it by hand, you could mess it up, so be careful.
 ;; Your init file should contain only one such instance.
 ;; If there is more than one, they won't work right.
 '(default ((t (:inherit nil :stipple nil :background "gainsboro" :foreground "black" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :height 144 :width normal :foundry "nil" :family "Monaco"))))
 '(cursor ((t (:background "orange red"))))
 '(custom-variable-tag ((t (:foreground "blue4" :weight bold))))
 '(font-lock-comment-face ((t (:foreground "dim gray"))))
 '(font-lock-function-name-face ((t (:foreground "Blue4"))))
 '(font-lock-keyword-face ((t (:foreground "Purple4"))))
 '(org-table ((t (:foreground "Blue4"))))
 '(widget-field ((t (:background "gray92")))))
